<?php
// TODO : @config
/**
 * Pour ajouter une entité, il faut absolument
 * son repository ainsi que le nom associé pour
 * la traduction.
 */
$entities = [
    [
        'repository' => 'Project\\\Entity\\\Project',
        'name' => 'project',
        'tabs' => [
            [
                'key' => 1,
                'name' => 'fieldGroup_tab_project',
            ],
            [
                'key' => 2,
                'name' => 'fieldGroup_tab_members',
            ],
            [
                'key' => 3,
                'name' => 'fieldGroup_tab_hierarchy',
            ],
            [
                'key' => 4,
                'name' => 'fieldGroup_tab_field',
            ],
            [
                'key' => 5,
                'name' => 'fieldGroup_tab_actors',
            ],
            [
                'key' => 6,
                'name' => 'fieldGroup_tab_territory',
            ],
            [
                'key' => 7,
                'name' => 'fieldGroup_tab_time',
            ],
            [
                'key' => 8,
                'name' => 'fieldGroup_tab_indicator',
            ],
            [
                'key' => 9,
                'name' => 'fieldGroup_tab_budget',
            ],
            [
                'key' => 10,
                'name' => 'fieldGroup_tab_convention',
            ],
            [
                'key' => 11,
                'name' => 'fieldGroup_tab_advancement',
            ],
            [
                'key' => 12,
                'name' => 'fieldGroup_tab_task',
            ],
            [
                'key' => 13,
                'name' => 'fieldGroup_tab_attachments',
            ]
        ]
    ],
    [
        'repository' => 'Directory\\\Entity\\\Contact',
        'name' => 'contact'
    ],
    [
        'repository' => 'Directory\\\Entity\\\Structure',
        'name' => 'structure'
    ],
];
?>
<ul class="breadcrumb">
    <li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
    <li><?= $this->translate('administration_module_title') ?></li>
    <li class="active"><?= $this->translate('field_nav_list') ?></li>
</ul>

<h1 class="page-title">
    <?= $this->icon('field') ?> <?= $this->translate('field_module_title') ?>
</h1>
<div class="row row-padding">
    <div class="col-xs-12">
        <div class="panel">
            <div class="panel-heading">
                <?= $this->translate('field_nav_list') ?>
            </div>
            <div class="panel-body">
                <ul class="nav nav-tabs">
                    <?php foreach ($entities as $i => $entity) : ?>
                        <li class="<?= ($i > 0 ? '' : 'active') ?>">
                            <a href="#<?= $entity['name'] ?>" data-toggle="tab" ng-click="tab<?= $entity['name'] ?>Loaded = true">
                                <?= $this->icon($entity['name'], 'fa fa-fw') ?>
                                <?= ucfirst($this->translate($entity['name'] . '_entity')) ?>
                            </a>
                        </li>
                    <?php endforeach; ?>
                </ul>

                <div class="tab-content">
                    <div class="separator"></div>
                    <?php foreach ($entities as $i => $entity) : ?>

                        <div <?= ($i > 0 ? 'ng-if="tab' . $entity['name'] . 'Loaded"' : '') ?> class="tab-pane <?= ($i > 0 ? '' : 'active') ?>" id="<?= $entity['name'] ?>" ng-controller="fieldIndexController as self" ng-init="self.init('<?= $entity['repository'] ?>');">
                            <?php if ($this->acl()->isAllowed('field:e:fieldGroup:c')) : ?>
                                <div class="row separator">
                                    <div class="col-xs-12">
                                        <button class="btn" ng-click="self.createGroup()">
                                            <?= $this->icon('create') ?>
                                            <?= $this->translate('fieldGroup_nav_form') ?>
                                        </button>
                                    </div>
                                </div>
                            <?php endif; ?>

                            <div ng-repeat="group in self.groups" class="well well-sm">
                                <div class="field-group separator">
                                    <form name="groupForm" class="inline" ng-submit="self.saveEditedGroup(group)">
                                        <span ng-show="self.editedGroup != group">
                                            <strong>{{group.name}}</strong>
                                            - {{ 'fieldGroup_enabled' | translate }}
                                            <input type="checkbox" name="enabled" autocomplete="off" ng-model="group.enabled" ng-change="self.enableGroup(group)" ng-disabled="!group._rights.update" />
                                        </span>                                        
                                        <div class="input-group" ng-show="self.editedGroup == group">
                                            <input type="text" name="name" class="form-control" required autocomplete="off" ng-model="self.editedGroupFields.name" />

                                            <label><?= ucfirst($this->translate('field_field_template')) ?></label>
                                            <template-select ng-model="group.templates" name="templates" multiple="true">
                                            </template-select>

                                            <span class="input-group-btn">
                                                <button class="btn btn-xs btn-default" type="submit" ng-disabled="self.editedGroupLoading">
                                                    <?= $this->icon('save', 'fa-fw') ?>
                                                </button>
                                                <button class="btn btn-xs btn-default" type="button" ng-disabled="self.editedGroupLoading" ng-click="self.editedGroup = null">
                                                    <?= $this->icon('close', 'fa-fw') ?>
                                                </button>
                                            </span>
                                        </div>                                        
                                        <?php if (isset($entity['tabs'])) : ?>
                                            <div class="form-group" ng-show="self.editedGroup == group">
                                                <label><?= ucfirst($this->translate('fieldGroup_englet')) ?></label>
                                                <select name="tab" class="form-control" ng-model="self.editedGroupFields.tab">
                                                    <option></option>
                                                    <?php foreach ($entity['tabs'] as $tab) : ?>
                                                        <option value="<?= $tab['key']; ?>"><?= $this->translate($tab['name']); ?></option>
                                                    <?php endforeach; ?>
                                                </select>
                                                <field-errors field="tab" errors="self.errors.fields"></field-errors>
                                            </div>
                                        <?php endif; ?>
                                    </form>

                                    <div class="btn-group" ng-show="self.editedGroup != group">
                                        <?php if ($this->acl()->isAllowed('field:e:field:c')) : ?>
                                            <button class="btn btn-default btn-xs" tooltip="<?= $this->translate('field_nav_form') ?>" ng-click="self.createField(group)">
                                                <?= $this->icon('create', 'fa-fw') ?>
                                            </button>
                                        <?php endif; ?>
                                        <button class="btn btn-default btn-xs" tooltip="<?= $this->translate('tooltip_edit') ?>" ng-click="self.editGroup(group)" ng-if="group._rights.update">
                                            <?= $this->icon('edit', 'fa-fw') ?>
                                        </button>
                                        <button class="btn btn-default btn-xs" tooltip="<?= $this->translate('tooltip_delete') ?>" ng-click="self.deleteGroup(group)" ng-if="group._rights.delete">
                                            <?= $this->icon('delete', 'fa-fw') ?>
                                        </button>
                                    </div>
                                </div>
                                <ul class="list-unstyled">
                                    <li ng-repeat="field in group.fields | orderBy: 'order'" class="field">
                                        {{field.name}} - {{ 'field_type_' + field.type | translate }}
                                        <div class="btn-group">
                                            <?php if ($this->acl()->isAllowed('field:e:field:u')) : ?>
                                                <button class="btn btn-default btn-xs" tooltip="<?= $this->translate('tooltip_edit') ?>" ng-click="self.editField(field, group)">
                                                    <?= $this->icon('edit', 'fa-fw') ?>
                                                </button>
                                            <?php endif; ?>
                                            <?php if ($this->acl()->isAllowed('field:e:field:d')) : ?>
                                                <button class="btn btn-default btn-xs" tooltip="<?= $this->translate('tooltip_delete') ?>" ng-click="self.deleteField(field, group)">
                                                    <?= $this->icon('delete', 'fa-fw') ?>
                                                </button>
                                            <?php endif; ?>
                                        </div>
                                    </li>
                                </ul>
                            </div>
                        </div>
                    <?php endforeach; ?>
                </div>

                <div id="fieldFormModal" class="modal fade" ng-controller="fieldFormController as self">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <form name="fieldForm" ng-submit="self.saveField();">
                                <div class="modal-header">
                                    {{self.panelTitle}}
                                </div>
                                <div class="modal-body">
                                    <div class="row">
                                        <div class="form-group required col-xs-12">
                                            <label><?= $this->translate('field_field_name') ?></label>
                                            <input type="text" name="name" class="form-control" required autocomplete="off" ng-model="self.field.name" />
                                            <field-errors field="name" errors="self.errors.fields"></field-errors>
                                        </div>
                                    </div>

                                    <div class="row">
                                        <div class="form-group col-xs-12">
                                            <label><?= $this->translate('field_field_help') ?></label>
                                            <input type="text" name="help" class="form-control" autocomplete="off" ng-model="self.field.help" />
                                        </div>
                                    </div>

                                    <div class="row">
                                        <div class="form-group required col-xs-12">
                                            <label><?= $this->translate('field_field_type') ?></label>
                                            <select class="form-control" required ng-model="self.field.type">
                                                <option value=""></option>
                                                <?php foreach (\Field\Entity\Field::getTypes() as $type) : ?>
                                                    <option value="<?= $type ?>">
                                                        <?= $this->translate('field_type_' . $type) ?>
                                                    </option>
                                                <?php endforeach ?>
                                                <option ng-if="self.group.entity === 'Directory\\Entity\\Contact'" value="consent">
                                                    <?= $this->translate('field_type_consent') ?>
                                                </option>
                                            </select>
                                            <field-errors field="type" errors="self.errors.fields"></field-errors>
                                        </div>
                                    </div>

                                    <div class="row">
                                        <div class="form-group required col-xs-12">
                                            <label><?= $this->translate('field_field_order') ?></label>
                                            <input type="number" name="order" required class="form-control" autocomplete="off" ng-model="self.field.order" />
                                            <field-errors field="order" errors="self.errors.fields"></field-errors>
                                        </div>
                                    </div>

                                    <div class="row">
                                        <div class="form-group col-xs-12">
                                            <label><?= $this->translate('field_field_placeholder') ?></label>
                                            <input type="text" name="placeholder" class="form-control" autocomplete="off" ng-model="self.field.placeholder" />
                                        </div>
                                    </div>

                                    <div class="row">
                                        <div class="form-group col-xs-12">
                                            <label><?= $this->translate('field_field_meta_required') ?></label>
                                            <input type="checkbox" name="required" autocomplete="off" ng-model="self.field.meta.required" />
                                        </div>
                                    </div>

                                    <div class="row" ng-show="self.field.type == '<?= \Field\Entity\Field::TYPE_TEXT ?>'">
                                        <div class="col-xs-12">
                                            <label><?= $this->translate('field_field_meta_unique') ?></label>
                                            <input type="checkbox" name="unique" autocomplete="off" ng-model="self.field.meta.unique" />
                                        </div>
                                    </div>

                                    <div class="row" ng-show="self.field.type == '<?= \Field\Entity\Field::TYPE_RADIO ?>' ||
                                                              self.field.type == '<?= \Field\Entity\Field::TYPE_CHECKBOX ?>' ||
                                                              self.field.type == '<?= \Field\Entity\Field::TYPE_SELECT ?>'">
                                        <div class="col-xs-12">
                                            <button class="btn separator" type="button" ng-click="self.addValue();">
                                                <?= $this->icon('create') ?>
                                                <?= $this->translate('field_add_value') ?>
                                            </button>
                                            <table class="table">
                                                <tr ng-repeat="value in self.field.meta.values">
                                                    <td>
                                                        <input type="text" required ng-model="value.v" class="form-control" />
                                                    </td>
                                                    <td>
                                                        <button class="btn btn-default btn-xs" type="button" ng-click="self.deleteValue(value)">
                                                            <?= $this->icon('delete', 'fa-fw') ?>
                                                        </button>
                                                    </td>
                                                </tr>
                                            </table>
                                        </div>
                                    </div>
                                </div>
                                <div class="modal-footer">
                                    <button class="btn btn-default" type="button" data-dismiss="modal">
                                        <?= $this->translate('close') ?>
                                    </button>
                                    <button class="btn btn-submit" ng-disabled="self.loading.save">
                                        <?= $this->icon('loading', '', ['ng-if' => 'self.loading.save']) ?>
                                        <?= $this->translate('save') ?>
                                    </button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<?php
$this->angular('js/src/field/controller/index.js');
$this->angular('js/src/field/controller/form.js');
$this->angular('js/src/field/service/fieldGroup.js');
$this->angular('js/src/field/service/field.js');
$this->angular('js/src/field/directive/templateSelect.js');

$this->angular('js/src/project/service/template.js');
